<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!ENTITY html-ss 
  PUBLIC "-//Norman Walsh//DOCUMENT DocBook HTML Stylesheet//EN" CDATA dsssl>
<!ENTITY print-ss
  PUBLIC "-//Norman Walsh//DOCUMENT DocBook Print Stylesheet//EN" CDATA dsssl>
]>
<style-sheet>
<style-specification id="print" use="print-stylesheet">
<style-specification-body> 

;; customize the print stylesheet

</style-specification-body>
</style-specification>
<style-specification id="html" use="html-stylesheet">
<style-specification-body> 

;; standard stylesheet options
(define %generate-legalnotice-link% #t)
(define html-index #t)
(define html-index-filename "sip-index")
(define %use-id-as-filename% #t)
(define %html-ext% ".html")

;; my choice of chunking 
;; (override dbchunk.dsl)
(define (chunk-element-list)
  (list (normalize "preface")
	(normalize "chapter")
	(normalize "appendix") 
	(normalize "article")
	(normalize "glossary")
	(normalize "bibliography")
	(normalize "index")
	(normalize "colophon")
	(normalize "setindex")
	(normalize "reference")
;;	(normalize "refentry")
	(normalize "part")
	(normalize "sect1") 
	(normalize "section") 
	(normalize "book") ;; just in case nothing else matches...
	(normalize "set")  ;; sets are definitely chunks...
	))

(define (chunk-section-depth)
  2)

(define (chunk? #!optional (nd (current-node)))
  (let* ((notchunk (or (and (equal? (gi nd) (normalize "bibliography"))
			    (not (or (equal? (gi (parent nd)) (normalize "book"))
				     (equal? (gi (parent nd)) (normalize "article")))))
		       (and (equal? (gi nd) (normalize "section"))
			    (equal? (gi (parent nd)) (normalize "section"))
			    (>= (section-element-depth nd)
				(chunk-section-depth)))
	               (equal? (dbhtml-value nd "chunk") "no")
		       (equal? (dbhtml-value (parent nd) "chunk") "no") ))
	 (maybechunk (not notchunk)))
    (if (node-list=? nd (sgml-root-element))
	#t
	(if (or nochunks
		(equal? (dbhtml-value (sgml-root-element) "chunk") "no"))
	    #f
	    (if (member (gi nd) (chunk-element-list))
		(if (combined-chunk? nd)
		    #f
		    maybechunk)
		#f)))))

;; More section tocs (not only on the first level)
;; (override dbsect.dsl)
(define ($section-body$)
  (make element gi: "DIV"
	attributes: (list (list "CLASS" (gi)))
	($section-separator$)
	($section-title$)

	(if (not (node-list-empty? (select-elements (children (current-node))
						    (normalize "refentry"))))
	    (build-toc (current-node) 1)
	    (build-toc (current-node)
  	      (toc-depth (current-node))))

	(process-children)))

;; ruler line above each refentry (if not in a chunk of its own)
;; (override dbrfntry.dsl)
(define ($refentry-body$)
  (let ((id (element-id (current-node))))
    (make sequence 
      (if (not (chunk?))
            (make empty-element gi: "HR")
            (empty-sosofo))
      (make element gi: "H1"
	    (make element gi: "A"
		  attributes: (list (list "NAME" id))
		  (element-title-sosofo (current-node))))
      (process-children))))

;; some more indentation
;; (override dbrfntry.dsl)
(element (refsect2 para) 
  (make element gi: "BLOCKQUOTE"
    ($block-container$)))

</style-specification-body>
</style-specification>
<external-specification id="print-stylesheet" document="print-ss">
<external-specification id="html-stylesheet"  document="html-ss">
</style-sheet>
